/*
	Coverage Master winAMS
	Tutorial v6.1.0
	Not used in practice

	Copyright(c) GAIO TECHNOLOGY CO., LTD
*/

// 
#define TRUE  1
#define FALSE 0


unsigned int *IRQ_COUNT  = (unsigned int *)0x04000000; // i/o PORT
unsigned int *TIM_ENABLE = (unsigned int *)0x04000004; // i/o PORT

void main()
{
	// Application program here
}


// Exercise 1) Simple function sample
//             C0 coverage to 100%.
/*
    "enable" : function "enable" flag (always returns 0 when 0)
	"mode"   : operation mode
	"input"  : input data
	return value : "gb_result.data", "gb_result.ret_code"
*/

// global variables
struct ST_PARAM
{
 	int data;
	int ret_code;
} gb_result;

void func1( int enable, int mode, int input )
{
	if( enable )
	{
		switch( mode )
		{
		case 0:
			gb_result.data = input;
			break;
		case 1:
			gb_result.data = input * 10;
			break;
		case 2:
			gb_result.data = input * 100;
			break;
		case 3:
			if( input>100 ) 
				gb_result.data = 10000;
			else
				gb_result.data = input*100;
			break;
		default:
			gb_result.data = -1;
		}
		// return code
		gb_result.ret_code = TRUE;
	}
	else
	{
		gb_result.data = 0;
		gb_result.ret_code = FALSE;
	}
}



char *gb_port1;    // i/o port input
int  *gb_data_out; // result

/*
	(Exercise 2) Function Sample with Pointer Variable Argument
	"mode"     : Operation mode
	"*data_in" : Input data
	return value : "*data_out"
*/
void func2( int mode, int *data_in )
{
	if( *gb_port1 & 0x00000001 ) // When the least significant bit is 1
	{
		switch( mode )
		{
		case 0:
			*gb_data_out = *data_in;
			break;
		case 1:
			*gb_data_out = *data_in * 10;
			break;
		case 2:
			*gb_data_out = *data_in * 100;
			break;
		case 3:
			if( *data_in > 100 ) 
				*gb_data_out = 10000;
			else
				*gb_data_out = *data_in*100;
			break;
		default:
			*gb_data_out = -1;
		}
	}
	else
	{
		*gb_data_out = 0;
	}
}


// Exercise 3) Function sample using stub function
//  * Input/output conditions are the same as func1()
/* 
	"enable" : function enable flag (always returns 0 when 0)
	"mode"   : operation mode
	"input"  : input data
	return value : "gb_result.data", "gb_result.ret_code"
*/

// simple computation subfunction (called as is)
int func3_sub_calc( int in )
{
	return in * 10;
}

unsigned char data_table[100];

// Function returning a return value (changed to a stub function)
int func3_sub_read_io( int index )
{
	// Return value depends on "data_table" and is complex
	if( data_table[index]>0x7f )
	{
		return data_table[index];
	}
	else
	{
		return -data_table[index];
	}	
}

void func3( int enable, int mode )
{
	int retval;
	
	if( enable )
	{
		// Create a stub function and set the return value to any value.
		retval = func3_sub_read_io( mode );
		
		// Branching with return value
		switch( retval )
		{
			case 0:
				gb_result.data = 0;
				break;
			case 1:
				gb_result.data = 50;
				break;
			case 2:
				gb_result.data = 100;
				break;
			default:
				gb_result.data = -1;
		}
		gb_result.ret_code = TRUE;
	}
	else
	{
		gb_result.data = 0;
		gb_result.ret_code = FALSE;
	}
}


// (Exercise 4) Data satisfying C1 coverage in conjunction with CasePlayer2
//              Automatic creation function
//

// Group of global variables, including unused and irrelevant ones
// Analyze variables used by "func4" in CasePlayer2
int gb_input;
int gb_output;
int gb_valA;
int gb_valB;
int gb_valC;
int gb_valD;
int  gb_a, gb_b, gb_c, gb_d, gb_out;
char gb_unused1, gb_unused2;


int func4( int code )
{
	int return_value=FALSE;	
	int i;


	if( gb_a > 10 )
	{
		if( gb_b > 20 && gb_c > 30 )
		{
			gb_out = 1;
		}
		else
		{
			gb_out = -1;
		}
		return_value = FALSE;
	}
	else
	{
		switch( code )
		{
			case 1:
				gb_out = 1;
				break;
			case 2:
				gb_out = 2;
				break;
			case 3:
				gb_out = 3;
				break;
			default:
				gb_out = -1;
				break;	
		}
		return_value = FALSE;
	}

	// When there are dynamically changing boundary values (gb_out)
	// When the static analysis function of CasePlayer2 cannot handle the case.
	if( gb_d == gb_out )
	{
		gb_out = 4;
	}
	else
	{
		gb_out = 5;		
	}

	return return_value;
}

/*------------------------------------------------------------------------------
< function func5 design specification >

For the two inputs "input1" and "input2", the value is determined 
by the mode switching value (mode) and output to "gb_result.data".
The ON/OFF of the entire function is determined by the input flag "enable".

Input: (all arguments)
  "enable" (flag)   : function ON/OFF OFF Output "gb_result"$B"*(B(0, FALSE)
  "mode" (variable) : mode switch 0: Output "gb_result"$B"*(B("input1", TRUE)
                                  1: Output "gb_result"$B"*(B("input2", TRUE)
                                  2: Output "gb_result"$B"*(B("input1"+"input2", TRUE)
                                  default: Output "gb_result"$B"*(B(255, TRUE)
  "input1" (variable) : "input1" Range (0 to 150)
  "input2" (variable) : "input2" Range (0 to 150)

Output: (global structure)
  "gb_result.data"     : Output data
  "gb_result.ret_code" : Error code (TRUE when function is ON, FALSE otherwise)
--------------------------------------------------------------------------------*/
void func5( int enable, int mode, unsigned char input1, unsigned char input2 )
{
  // Determine function (ON/OFF)
  if( enable )
  {
    // Processing for each mode
    switch( mode )
    {
      case 0:
        gb_result.data = input1;
        break;
      case 1:
        gb_result.data = input2;
        break;
      case 2:
        gb_result.data = input1 + input2;
        break;
      default:
        gb_result.data = 255;
        break;
    }
    gb_result.ret_code = TRUE;

  }
  else
  {
    gb_result.data = 0;
    gb_result.ret_code = FALSE;
  }
}

// (Applied) Automatic MC/DC data creation
//   *If there is enough time...

int func_mcdc_01( int x, int y, int z )
{
	if( ( x>10 && y>20 ) || z>30 ) /* Compound condition setting */
	{
		return TRUE; // Returns TRUE when condition TRUE
	}
	else
	{
		return FALSE; // Returns FALSE if the condition FALSE
	}
}


